VERSION 4.00
Begin VB.Form Darkness 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   BorderStyle     =   3  'Fixed Dialog
   ClientHeight    =   330
   ClientLeft      =   1980
   ClientTop       =   1920
   ClientWidth     =   4455
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   Height          =   735
   KeyPreview      =   -1  'True
   Left            =   1920
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   22
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   297
   ShowInTaskbar   =   0   'False
   Top             =   1575
   Width           =   4575
   Begin VB.Timer Timer 
      Index           =   0
      Interval        =   1
      Left            =   1620
      Top             =   420
   End
   Begin VB.CommandButton Selection 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Default         =   -1  'True
      Height          =   315
      Index           =   0
      Left            =   3180
      TabIndex        =   4
      Top             =   900
      Width           =   1215
   End
   Begin VB.PictureBox ShowBox 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   1920
      Left            =   3960
      ScaleHeight     =   128
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   3
      Top             =   4860
      Width           =   1920
   End
   Begin VB.PictureBox Backlay 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   1920
      Left            =   7380
      Picture         =   "DARKNESS.frx":0000
      ScaleHeight     =   128
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   2
      Top             =   4560
      Visible         =   0   'False
      Width           =   1920
   End
   Begin VB.PictureBox Overlay 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   1920
      Left            =   7020
      Picture         =   "DARKNESS.frx":084A
      ScaleHeight     =   128
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   1
      Top             =   4320
      Visible         =   0   'False
      Width           =   1920
   End
   Begin VB.PictureBox PictureBox 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3210
      Left            =   780
      Picture         =   "DARKNESS.frx":1094
      ScaleHeight     =   214
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   457
      TabIndex        =   0
      Top             =   4980
      Visible         =   0   'False
      Width           =   6855
   End
End
Attribute VB_Name = "Darkness"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

Dim mbTimerTimering%
Dim miDirection%, miIncrement%
Dim tLocation As XYType
Dim tDimension As XYType

Private Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"
            
    ShowBox.Visible = True
    Me.Refresh
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub Form_Load()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Load"

    Me.Width = PictureBox.Width * Screen.TwipsPerPixelX + (Me.Width - Me.ScaleWidth * Screen.TwipsPerPixelX)
    Me.Height = PictureBox.Height * Screen.TwipsPerPixelY + (Me.Height - Me.ScaleHeight * Screen.TwipsPerPixelY)
    
    PictureBox.Move 0, 0
    Selection(0).Move Me.ScaleWidth - Selection(0).Width, Me.ScaleHeight - Selection(0).Height
    ShowBox.Visible = False
'   Center Form
    Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
    
    tDimension.X = Overlay.Width
    tDimension.Y = Overlay.Height
    Timer(0).Enabled = False
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub




Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & "Form_MouseDown"

    If (Button = 1) Then
        ShowBox.Visible = False
        Timer(0).Enabled = False
        PictureBox.Visible = True
    Else
        miDirection = 1
        tLocation.X = X
        tLocation.Y = Y
        Timer(0).Enabled = True
    End If
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & "Form_MouseMove"

    If (Button = 1) Then
        ShowBox.Visible = False
        Timer(0).Enabled = False
        PictureBox.Visible = True
    ElseIf Not Timer(0).Enabled Then
        miDirection = 0
        Call Timer_Timer(0)
    End If
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    miDirection = -1
    tLocation.X = X
    tLocation.Y = Y
    Timer(0).Enabled = True
End Sub


Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Unload"

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub PictureBox_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".PictureBox_MouseDown"
    
    If (Button = 2) Then
        PictureBox.Visible = False
        Timer(0).Enabled = True
        ShowBox.Visible = True
    End If
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub PictureBox_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".PictureBox_MouseMove"
    
    If (Button = 2) Then
        PictureBox.Visible = False
        Timer(0).Enabled = True
        ShowBox.Visible = True
    End If
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Select Case Index
    Case 0
        Unload Me
    End Select
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub




Private Sub ShowBox_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".ShowBox_MouseDown"
    
    If (Button = 1) Then
        PictureBox.Visible = False
        Timer(0).Enabled = True
        ShowBox.Visible = True
    Else
        miDirection = 1
        tLocation.X = ShowBox.Left + X
        tLocation.Y = ShowBox.Top + Y
        Timer(0).Enabled = True
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub ShowBox_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".ShowBox_MouseMove"
    
    If (Button = 1) Then
        PictureBox.Visible = False
        Timer(0).Enabled = True
        ShowBox.Visible = True
    ElseIf Not Timer(0).Enabled Then
        miDirection = 0
        Call Timer_Timer(0)
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub ShowBox_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    miDirection = -1
    tLocation.X = ShowBox.Left + X
    tLocation.Y = ShowBox.Top + Y
    Timer(0).Enabled = True
End Sub


Private Sub Timer_Timer(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Timer_Timer"
    
'    If mbTimerTimering Then Exit Sub
'    mbTimerTimering = True
    
    Dim tXY As XYType
    Call GetCursorPos(tXY)
    tLocation.X = tXY.X - (Me.Left \ Screen.TwipsPerPixelX)
    tLocation.Y = tXY.Y - (Me.Top \ Screen.TwipsPerPixelY)
    
    Dim n&
    Dim iSize%: iSize = miIncrement \ 2
    If (miIncrement < 0) Then
        miIncrement = 0
        Timer(Index).Enabled = False
        mbTimerTimering = False
        Exit Sub
    ElseIf (miIncrement > tDimension.X) Then
        miIncrement = tDimension.X
        Timer(Index).Enabled = False
        mbTimerTimering = False
        Exit Sub
    End If
    
    Call BitBlt(ShowBox.hDC, 0, 0, tDimension.X, tDimension.Y, PictureBox.hDC, tLocation.X - iSize, tLocation.Y - iSize, SRCCOPY)
    If (miIncrement = tDimension.X) Then
        Call BitBlt(ShowBox.hDC, 0, 0, miIncrement, miIncrement, Backlay.hDC, 0, 0, SRCINFUNCTIONST)
        Call BitBlt(ShowBox.hDC, 0, 0, miIncrement, miIncrement, Overlay.hDC, 0, 0, SRCAND)
    Else
        Call BitBlt(ShowBox.hDC, 0, 0, iSize, iSize, Backlay.hDC, 0, 0, SRCINFUNCTIONST)
        Call BitBlt(ShowBox.hDC, 0, 0, iSize, iSize, Overlay.hDC, 0, 0, SRCAND)
        Call BitBlt(ShowBox.hDC, iSize, 0, iSize, iSize, Backlay.hDC, tDimension.X - iSize, 0, SRCINFUNCTIONST)
        Call BitBlt(ShowBox.hDC, iSize, 0, iSize, iSize, Overlay.hDC, tDimension.X - iSize, 0, SRCAND)
        Call BitBlt(ShowBox.hDC, 0, iSize, iSize, iSize, Backlay.hDC, 0, tDimension.Y - iSize, SRCINFUNCTIONST)
        Call BitBlt(ShowBox.hDC, 0, iSize, iSize, iSize, Overlay.hDC, 0, tDimension.Y - iSize, SRCAND)
        Call BitBlt(ShowBox.hDC, iSize, iSize, iSize, iSize, Backlay.hDC, tDimension.X - iSize, tDimension.Y - iSize, SRCINFUNCTIONST)
        Call BitBlt(ShowBox.hDC, iSize, iSize, iSize, iSize, Overlay.hDC, tDimension.X - iSize, tDimension.Y - iSize, SRCAND)
    End If
    ShowBox.Move tLocation.X - iSize, tLocation.Y - iSize, iSize * 2, iSize * 2
    ShowBox.Refresh
    
    miIncrement = miIncrement + miDirection * 10
    
    mbTimerTimering = False
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


