VERSION 4.00
Begin VB.Form Find 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find"
   ClientHeight    =   2325
   ClientLeft      =   3390
   ClientTop       =   2940
   ClientWidth     =   3915
   ControlBox      =   0   'False
   Height          =   2730
   KeyPreview      =   -1  'True
   Left            =   3330
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2325
   ScaleWidth      =   3915
   ShowInTaskbar   =   0   'False
   Top             =   2595
   Visible         =   0   'False
   Width           =   4035
   Begin VB.CommandButton Relation 
      Caption         =   "="
      Height          =   315
      HelpContextID   =   20200
      Index           =   0
      Left            =   840
      TabIndex        =   7
      Top             =   105
      Visible         =   0   'False
      Width           =   330
   End
   Begin VB.CheckBox NoOption 
      Caption         =   "No"
      Height          =   330
      Index           =   1
      Left            =   2520
      TabIndex        =   6
      Top             =   840
      Visible         =   0   'False
      Width           =   1275
   End
   Begin VB.CheckBox YesOption 
      Caption         =   "Yes"
      Height          =   330
      Index           =   0
      Left            =   1155
      TabIndex        =   5
      Top             =   840
      Visible         =   0   'False
      Width           =   1275
   End
   Begin VB.ComboBox List 
      Height          =   315
      Index           =   0
      ItemData        =   "FIND.frx":0000
      Left            =   1155
      List            =   "FIND.frx":0002
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   420
      Visible         =   0   'False
      Width           =   2655
   End
   Begin VB.CommandButton Selection 
      Caption         =   "&Find"
      Default         =   -1  'True
      Height          =   315
      HelpContextID   =   20200
      Index           =   0
      Left            =   1470
      TabIndex        =   3
      Top             =   1920
      Width           =   1275
   End
   Begin VB.TextBox Text 
      Height          =   315
      HelpContextID   =   10100
      Index           =   0
      Left            =   1155
      TabIndex        =   1
      Top             =   60
      Visible         =   0   'False
      Width           =   2670
   End
   Begin VB.CommandButton Selection 
      Caption         =   "&Exit"
      Height          =   315
      HelpContextID   =   20200
      Index           =   1
      Left            =   2520
      TabIndex        =   0
      Top             =   1920
      Width           =   1275
   End
   Begin VB.Label Label 
      BackStyle       =   0  'Transparent
      Caption         =   "UPC:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Visible         =   0   'False
      Width           =   1050
   End
End
Attribute VB_Name = "Find"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private poGrid As GridObj              ' The database object where the queried
                                        ' table exists
Private poForm As New FormObj                                        ' table exists

Private pbShowFormUsed As Boolean       ' Whether ShowForm was used to load form

Private pbInitialization%
Private pbReInitializing%


Private Sub Form_Resize()
    If Not pbInitialization Then poForm.xResize
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set Find = Nothing
End Sub

'   ShowForm
'   PURPOSE:
'       - This routine sets up the Find form before it is shown on screen
'   PARAMETERS:
'       - Grid (GridObj)
'           - The grid that is controlling the queried table
'   RETURNS:
'       - None
Public Sub ShowForm(roGrid As GridObj)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".xShow"
    
'   Set a reference to the DBase object given
    Set poGrid = roGrid
    
    pbShowFormUsed = True
    
'   Load the form
    Call Find.Form_Activate
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


'   Form_Activate
'   PURPOSE:
'       - Routine creates the required options to place on the screen
'       - Initializes all operating variables
'       - Displays the SortBy form on screen
'
'       - Assumes that ShowForm was used to show this form
'   PARAMETERS:
'       - None
'   RETURNS:
'       - None
Public Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"
    
    If Not pbInitialization Then
        pbInitialization = True
        pbReInitializing = True
        
        Dim n%, s%
        Dim tReturn As ExtractObj: Set tReturn = New ExtractObj
        Dim tColReturn As ExtractObj: Set tColReturn = New ExtractObj
        Dim sText$
        
        If Not pbShowFormUsed Then
            ExitProg sCurrentRoutine, "ShowForm was not used to create Find."
        End If
                        
        Relation(0).Left = Label(0).Left + Label(0).Width + 75
        Relation(0).Height = Text(0).Height
        
        Me.Width = (Me.Width - Me.ScaleWidth) + Relation(0).Left + Relation(0).Width + Text(0).Width + 75
        
    '   Create the fields required
        tReturn.gsValue = poGrid.gsFindFields
        For n = 1 To tReturn.giNumValues
            Load Label(n)
            Label(n).Caption = tReturn.gsaList(1, n)
            Label(n).Move Label(0).Left, Text(0).Top + (n - 1) * (Text(0).Height + 75)
            Label(n).Height = Text(0).Height
            Label(n).Visible = True
            
            Load Relation(n)
            Relation(n).Move Label(n).Left + Label(n).Width + 75, Label(n).Top
            Relation(n).Visible = True
            
            Select Case LCase$(tReturn.gsaList(2, n))
            Case FIND_NUMERIC
                Load Text(n)
                Text(n).Move Relation(0).Left + Relation(0).Width, Text(0).Top + (n - 1) * (Text(0).Height + 75), Text(0).Width / 2
                Text(n).Visible = True
            Case FIND_TEXT
                Load Text(n)
                Text(n).Move Relation(0).Left + Relation(0).Width, Text(0).Top + (n - 1) * (Text(0).Height + 75)
                Text(n).Visible = True
            Case FIND_YES_NO
                Load YesOption(n)
                Load NoOption(n)
                YesOption(n).Move Relation(0).Left + Relation(0).Width, Text(0).Top + (n - 1) * (Text(0).Height + 75)
                YesOption(n).Visible = True
                NoOption(n).Move YesOption(0).Left + YesOption(0).Width, Text(0).Top + (n - 1) * (Text(0).Height + 75)
                NoOption(n).Visible = True
            Case FIND_LIST
                Load List(n)
                List(n).Move Relation(0).Left + Relation(0).Width, Text(0).Top + (n - 1) * (Text(0).Height + 75)
                
'               Load the data for this list from the column
                poGrid.gsCurColumn = tReturn.gsaList(1, n)
                tColReturn.gsValue = poGrid.gsValidList
                If (tColReturn.giNumIndeces = 1) Then
'                   The value is the same as the text in this case
                    For s = 0 To tColReturn.giNumValues - 1
                        List(n).AddItem tColReturn.gsaList(1, s + 1), s
                        List(n).ItemData(s) = tColReturn.gsaList(1, s + 1)
                    Next s
                Else
                    For s = 0 To tColReturn.giNumValues - 1
                        List(n).AddItem tColReturn.gsaList(1, s + 1), s
                        List(n).ItemData(s) = tColReturn.gsaList(2, s + 1)
                    Next s
                End If
                If (tColReturn.giNumValues > 0) Then
                    List(n).Visible = True
                Else
                    Relation(n).Visible = False
                End If
            End Select
        Next n
                        
        Selection(1).Left = (Me.ScaleWidth - Selection(0).Width) - 75
        Selection(0).Left = Selection(1).Left - (Selection(0).Width + 75)
        Selection(0).Top = Label(n - 1).Top + Label(n - 1).Height + 75
        Selection(1).Top = Selection(0).Top
    
        Me.Height = (Me.Height - Me.ScaleHeight) + Selection(1).Top + Selection(1).Height + 75
    
        If (poGrid.giNumKeys = 0) Then
            MsgBox "Sorry, but since NumKeys is 0, you can't sort on this table."
            Unload Me
            Exit Sub
        End If
    
'       Center the form on the screen
        Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
       
        pbReInitializing = False

        poForm.xInitialize Me
        poForm.glScaleHeight = Me.ScaleHeight
        poForm.glScaleWidth = Me.ScaleWidth
        
        poForm.xCenter

        Me.Visible = True
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub Form_Deactivate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Deactivate"
    
    Unload Me
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_KeyDown"
    
    Select Case KeyCode
    Case 46 ' DEL
        Select Case ActiveControl.Name
        Case "List"
            ActiveControl.ListIndex = -1
        Case "YesOption"
            ActiveControl.Value = 0
        Case "NoOption"
            ActiveControl.Value = 0
        Case "Text"
            ActiveControl.Text = ""
        Case "Relation"
            ActiveControl.Caption = "="
        End Select
    End Select
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub NoOption_Click(Index As Integer)
    YesOption(Index).Value = Abs(Not NoOption(Index).Value)
End Sub

Private Sub Relation_Click(riIndex As Integer)
    Select Case Relation(riIndex).Caption
    Case "="
        Relation(riIndex).Caption = "<="
    Case "<="
        Relation(riIndex).Caption = "<"
    Case "<"
        Relation(riIndex).Caption = "<>"
    Case "<>"
        Relation(riIndex).Caption = ">"
    Case ">"
        Relation(riIndex).Caption = ">="
    Case ">="
        Relation(riIndex).Caption = "="
    Case Else
        Relation(riIndex).Caption = "="
    End Select
End Sub

Private Sub Selection_Click(riIndex As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Dim tReturn As ExtractObj: Set tReturn = New ExtractObj
    Dim n%
    Dim sValue$, sBuffer$
    Dim sSortBuffer$
    
    Select Case riIndex
    Case 0  'Ok
'       Validate the data given

        sBuffer = ""
        sSortBuffer = ""
        tReturn.gsValue = poGrid.gsFindFields
        For n = 1 To tReturn.giNumValues
            Select Case LCase$(tReturn.gsaList(2, n))
            Case FIND_TEXT, FIND_NUMERIC
                sValue = Text(n).Text
            Case FIND_YES_NO
                If (YesOption(n).Value = 1) Then
                    sValue = "1"
                ElseIf (NoOption(n).Value = 1) Then
                    sValue = "0"
                Else
'                   This is not a find criteria
                    sValue = ""
                End If
            Case FIND_LIST
                If (List(n).ListIndex = -1) Then
                    sValue = ""
                Else
                    sValue = Format$(List(n).ItemData(List(n).ListIndex))
                End If
            End Select
            
            If (sValue <> "") Then
                If Not poGrid.xValidate(tReturn.gsaList(1, n), sValue) Then Exit Sub
                        
                If (IsNumeric(sValue) And (LCase$(tReturn.gsaList(2, n)) <> FIND_TEXT)) Then
                    sBuffer = sBuffer & tReturn.gsaList(1, n) & " " & Relation(n).Caption & " " & sValue
                Else
                    sBuffer = sBuffer & tReturn.gsaList(1, n) & " " & Relation(n).Caption & " '" & sValue & "'"
                End If
                sSortBuffer = sSortBuffer & "[" & tReturn.gsaList(1, n) & "] ASC "
                sBuffer = sBuffer & " AND "
            End If
        Next n
                                            
        If (sBuffer <> "") Then
            sBuffer = Left$(sBuffer, Len(sBuffer) - Len(" AND "))
            If Not poGrid.xFind(sBuffer) Then
                MsgBox "Sorry but no records exit matching that criteria."
            Else
                poGrid.xMassFind sBuffer
                Unload Me
            End If
        Else
            poGrid.xMassFind ""
            Unload Me
        End If
        
    Case 1  'Cancel
        Unload Me
    End Select

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub YesOption_Click(Index As Integer)
    NoOption(Index).Value = Abs(Not YesOption(Index).Value)
End Sub


