VERSION 4.00
Begin VB.Form NewPwd 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "New Password"
   ClientHeight    =   945
   ClientLeft      =   3360
   ClientTop       =   4515
   ClientWidth     =   5325
   ControlBox      =   0   'False
   Height          =   1350
   Icon            =   "NEWPASS.frx":0000
   Left            =   3300
   LinkTopic       =   "Form5"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   945
   ScaleWidth      =   5325
   ShowInTaskbar   =   0   'False
   Top             =   4170
   Visible         =   0   'False
   Width           =   5445
   Begin VB.CommandButton Selection 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   315
      HelpContextID   =   20201
      Index           =   1
      Left            =   3990
      TabIndex        =   3
      Top             =   525
      Width           =   1275
   End
   Begin VB.CommandButton Selection 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   315
      HelpContextID   =   20200
      Index           =   0
      Left            =   3990
      TabIndex        =   2
      Top             =   105
      Width           =   1275
   End
   Begin VB.TextBox Text 
      Height          =   315
      HelpContextID   =   10100
      Index           =   1
      Left            =   1365
      PasswordChar    =   "*"
      TabIndex        =   0
      Top             =   105
      Width           =   2535
   End
   Begin VB.TextBox Text 
      Height          =   315
      HelpContextID   =   10100
      Index           =   2
      Left            =   1365
      PasswordChar    =   "*"
      TabIndex        =   1
      Top             =   525
      Width           =   2535
   End
   Begin VB.Label Label 
      BackStyle       =   0  'Transparent
      Caption         =   "New Password:"
      Height          =   255
      Index           =   1
      Left            =   105
      TabIndex        =   5
      Top             =   150
      Width           =   1155
   End
   Begin VB.Label Label 
      BackStyle       =   0  'Transparent
      Caption         =   "Verify New:"
      Height          =   375
      Index           =   2
      Left            =   105
      TabIndex        =   4
      Top             =   555
      Width           =   1275
   End
End
Attribute VB_Name = "NewPwd"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private pbShowFormUsed As Boolean       ' Whether ShowForm was used to load form
Private psPassword As String            ' The new password
Private Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"

    If Not pbShowFormUsed Then
        ExitProg sCurrentRoutine, "ShowForm was not used to create NewPwd."
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


'   Selection_Click
'   PURPOSE:
'       - Runs when a user hits a button
'       - Changes the password
'   PARAMETERS:
'       - Index (integer)
'           - Which button was pressed
'   RETURNS:
'       - None
Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".ChgPwd"
    
    Select Case Index
    Case 0  'Ok
'       Verify the passwords
        If (Trim$(Text(1).Text) <> Trim$(Text(2).Text)) Then
            MsgBox "Sorry, but the new password and the verification don't match."
            Unload Me
        ElseIf (Trim$(Text(1).Text) = "") Then
            MsgBox "Sorry, but the new password can't be blank."
            Unload Me
        Else
            psPassword = Trim$(Text(1).Text)
            MsgBox "Password change was successfull."
            Unload Me
        End If
    Case 1  'Cancel
        Unload Me
    End Select

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



'   ShowForm
'   PURPOSE:
'       - Returns the new password entered when the form is complete
'   PARAMETERS:
'       - None
'   RETURNS:
'       - (string)
'           - The new password
Public Function ShowForm$()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".ShowForm"
    
    Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
    
    pbShowFormUsed = True
    
    Me.Show 1
    ShowForm = psPassword

    Set NewPwd = Nothing
        
    Exit Function
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Function
