VERSION 4.00
Begin VB.Form Personnel 
   Caption         =   "Personnel"
   ClientHeight    =   2280
   ClientLeft      =   1005
   ClientTop       =   3360
   ClientWidth     =   7155
   ControlBox      =   0   'False
   Height          =   2685
   Icon            =   "PERSNNEL.frx":0000
   Left            =   945
   LinkTopic       =   "Form10"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2280
   ScaleWidth      =   7155
   Top             =   3015
   Width           =   7275
   Begin VBX.TrueGrid Table 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BackColor       =   &H00C0C0C0&
      DataSource      =   "DBase"
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      HeadingHeight   =   1
      Height          =   960
      HelpContextID   =   8100
      HorzLines       =   2  '3D
      Layout          =   "PERSNNEL.frx":030A
      LayoutIndex     =   1
      Left            =   105
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   0   'False
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   8
      Tag             =   "Table"
      Top             =   105
      UseBookmarks    =   -1  'True
      Width           =   6945
      WrapCellPointer =   0   'False
   End
   Begin Threed.SSFrame Frame 
      Height          =   1065
      Index           =   0
      Left            =   105
      TabIndex        =   0
      Top             =   1155
      Width           =   6945
      _version        =   65536
      _extentx        =   12250
      _extenty        =   1879
      _stockprops     =   14
      Begin VB.Data DBase 
         Connect         =   "Access"
         DatabaseName    =   ""
         Exclusive       =   0   'False
         Height          =   300
         Left            =   0
         Options         =   0
         ReadOnly        =   0   'False
         RecordsetType   =   1  'Dynaset
         RecordSource    =   ""
         Top             =   0
         Visible         =   0   'False
         Width           =   1140
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Exit"
         Height          =   315
         HelpContextID   =   20200
         Index           =   0
         Left            =   5565
         TabIndex        =   7
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Add"
         Height          =   315
         HelpContextID   =   20200
         Index           =   1
         Left            =   1470
         TabIndex        =   6
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Delete"
         Height          =   315
         HelpContextID   =   20200
         Index           =   2
         Left            =   2835
         TabIndex        =   5
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Print"
         Height          =   315
         HelpContextID   =   20200
         Index           =   4
         Left            =   4200
         TabIndex        =   4
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Sort by"
         Height          =   315
         HelpContextID   =   20200
         Index           =   5
         Left            =   4200
         TabIndex        =   3
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Find"
         Height          =   315
         HelpContextID   =   20200
         Index           =   6
         Left            =   5565
         TabIndex        =   2
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Set Pwd"
         Height          =   315
         HelpContextID   =   20200
         Index           =   7
         Left            =   105
         TabIndex        =   1
         Top             =   630
         Width           =   1275
      End
   End
End
Attribute VB_Name = "Personnel"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private poForm As FormObj
Private poGrid As GridObj


'   Form_Activate
'   PURPOSE:
'       - Required because both the Security and Store table could have been
'         changed while this form was inactive
'       - So both listings in the grid must be updated
'   PARAMETERS:
'       - None
'   RETURNS:
'       - None
Private Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"
    
    poGrid.gsCurColumn = "StoreID"
    goDBase.gsCurTable = "Store"
    poGrid.xSetGridColList goDBase.xGetList("StoreName", "StoreID")
    
    poGrid.gsCurColumn = "Security"
    goDBase.gsCurTable = "Security"
    poGrid.xSetGridColList goDBase.xGetList("Description", "Security")
    poGrid.gsValidList = ReturnPossibleLevels()

    If Not IsPermissible(PERMISSION_STORES) Then
        goDBase.gsCurTable = "Store"
        If goDBase.xFind("StoreID = " & Format$(gtSystem.iStoreID)) Then Me.Caption = "Personnel of " & Format$(goDBase.xGet("StoreName"))
    End If
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_Resize()
    poForm.xResize
End Sub

Private Sub Table_KeyPress(KeyAscii As Integer)
    poGrid.xSetKey KeyAscii
End Sub




Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Select Case Index
    Case 7  'Set Password
        If (Table.RowIndex > 0) And (poGrid.giNumRecords > 0) Then
'           Do some validation beforehand
            If Not poGrid.xValidate("Security", CStr(poGrid.xGet("Security"))) Then Exit Sub
            
            poGrid.xSet "password", NewPwd.ShowForm()
        End If
    Case 1  'Add
        If IsPermissible(PERMISSION_STORES) Then
            poGrid.xAddNew
        Else
            poGrid.xAddNew "(2) '|' StoreID | " & Format$(gtSystem.iStoreID)
        End If
    Case 0  'Exit
'       Search for personnel with blank passwords
        goDBase.gsCurTable = "Employee"
        If goDBase.xFind("password = '<default>'") Then
            MsgBox "Please set the password of Employee ID #" & Format$(goDBase.xGet("EmployeeID")) & "."
            Exit Sub
        End If
                
        Unload Me
    Case Else
        If xSelection(poGrid, Selection(Index)) Then Unload Me
    End Select

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set poForm = Nothing
    Set Personnel = Nothing
End Sub

Private Sub Table_EnterEdit()
    poGrid.xEnterEdit
End Sub


Private Sub Table_ExitEdit()
    poGrid.xExitEdit
End Sub



Private Sub Table_RowChange()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Table_RowChange"

    If (CStr(poGrid.xGet("username") & "") = gtSystem.sUserName) Then
'       The record to be deleted is the current user
        Selection(2).Enabled = False
        Exit Sub
    ElseIf (Val(poGrid.xGet("Security")) = 0) Then
'       The record to be deleted is an Administrator
'       Check to see if any other administrators exist
        goDBase.gsCurTable = "employee"
        If (goDBase.xCount("Security = 0") <= 1) Then
            Selection(2).Enabled = False
            Exit Sub
        End If
    End If

    Selection(2).Enabled = IsPermissible(PERMISSION_CHANGEPERSONNEL)

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

'   Table_Validate
'   PURPOSE:
'       - Makes sure that all the data entering the database is proper
'   PARAMETERS:
'       - Row (long)
'           - The row the change is being made on
'       - Column (integer)
'           - The column the change is being made in
'       - Value (string)
'           - The new value
'       - Cancel (integer)
'           - Whether or not to reenter or exit edit mode
'   RETURNS:
'       - Cancel (integer)
'           - TRUE : Cancel the update and return to edit mode
'           - FALSE: Update the database and exit edit mode
Private Sub Table_Validate(Row As Long, riCol As Integer, rsValue As String, Cancel As Integer)
    Cancel = Not poGrid.xValidate(riCol, rsValue)
End Sub

Private Sub Form_Load()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Load"

    Set poForm = New FormObj
    
    poForm.xInitialize Me

        poForm.xAddResizeObject Table.Name, FINDEX_NONE
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_STRETCH
    
    poForm.xAddResizeObject Frame(0).Name, 0
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_MOVE

    poForm.xAddResizeObject Selection(0).Name, FINDEX_ALL
    poForm.xAddStyle FRESIZE_X_MOVE

'   Bind the data control to the DBaseObj
    Set poGrid = New GridObj
    
    poGrid.xInitialize Me, Me.Table, App.Path & DATABASE_NAME, DBase
    poGrid.gsNotWhileEdit = Selection(0).Name
    
    If IsPermissible(PERMISSION_STORES) Then
        poGrid.xAddTable "employee", ""
        poGrid.gsSortFields = "'|' StoreID | EmployeeID | FirstName | LastName | Security | UserName | Position"
        poGrid.gsFindFields = "(2) '|' StoreID | l | EmployeeID | n | FirstName | t | LastName | t | Security | l | UserName | t | Position | t"
    Else
        poGrid.xAddTable "employee", "StoreID = " & Format$(gtSystem.iStoreID)
        poGrid.gsSortFields = "'|' EmployeeID | FirstName | LastName | Security | UserName | Position"
        poGrid.gsFindFields = "(2) '|' EmployeeID | n | FirstName | t | LastName | t | Security | l | UserName | t | Position | t"
        
        Table.SplitIndex = 1
        poGrid.xVisible "StoreID", False
    
        goDBase.gsCurTable = "Store"
        If goDBase.xFind("StoreID = " & Format$(gtSystem.iStoreID)) Then Me.Caption = "Personnel of " & Format$(goDBase.xGet("StoreName"))
    End If
    poGrid.giNumKeys = 3
    
    poGrid.gsValidationColumn = "Security"
    
    poGrid.xAddIndex "EmployeeID", True
    poGrid.gsIndexField = "employeeID"
    
    poGrid.xAddIndex "UserName", True
    poGrid.gsIndexField = "username"
    
'   Setup the column validation rules
    poGrid.xAddColumn "StoreID"
    goDBase.gsCurTable = "Store"
    poGrid.xSetGridColList goDBase.xGetList("StoreName", "StoreID")
    poGrid.xAddRule VRULE_ISINLIST

    poGrid.xAddColumn "EmployeeID"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE
    
    poGrid.xAddColumn "FirstName"
    poGrid.xAddRule VRULE_ISMAX_LEN, 255

    poGrid.xAddColumn "LastName"
    poGrid.xAddRule VRULE_ISMAX_LEN, 255
    
    poGrid.xAddColumn "UserName"
    poGrid.xAddRule VRULE_ISMIN_LEN, 1
    poGrid.xAddRule VRULE_ISMAX_LEN, 255
    
    poGrid.xAddColumn "Security"
    goDBase.gsCurTable = "Security"
    poGrid.xSetGridColList goDBase.xGetList("Description", "Security")
    poGrid.gsValidList = ReturnPossibleLevels()
    poGrid.xAddRule VRULE_ISINLIST

    poGrid.xAddColumn "Position"
    poGrid.xAddRule VRULE_ISMAX_LEN, 255
    
    Selection(4).Enabled = IsPermissible(PERMISSION_PRINTING)
    Table.Editable = IsPermissible(PERMISSION_CHANGEPERSONNEL)
    Selection(1).Enabled = IsPermissible(PERMISSION_CHANGEPERSONNEL)
    Selection(2).Enabled = IsPermissible(PERMISSION_CHANGEPERSONNEL)
    Selection(7).Enabled = IsPermissible(PERMISSION_CHANGEPERSONNEL)
    
    poForm.xCenter

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



