VERSION 4.00
Begin VB.Form Products 
   Caption         =   "Products Available"
   ClientHeight    =   2295
   ClientLeft      =   1230
   ClientTop       =   3450
   ClientWidth     =   6930
   ControlBox      =   0   'False
   Height          =   2700
   Icon            =   "PRODUCTS.frx":0000
   Left            =   1170
   LinkTopic       =   "Form10"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   6930
   Top             =   3105
   Width           =   7050
   Begin VB.Data DBase 
      Connect         =   "Access"
      DatabaseName    =   ""
      Exclusive       =   0   'False
      Height          =   300
      Left            =   3045
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   ""
      Top             =   1155
      Visible         =   0   'False
      Width           =   1140
   End
   Begin VBX.TrueGrid Table 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BackColor       =   &H00C0C0C0&
      DataSource      =   "DBase"
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      HeadingHeight   =   2
      Height          =   960
      HelpContextID   =   8100
      HorzLines       =   2  '3D
      Layout          =   "PRODUCTS.frx":030A
      LayoutIndex     =   1
      Left            =   105
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   -1  'True
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   0
      Tag             =   "Table"
      Top             =   105
      UseBookmarks    =   -1  'True
      Width           =   6735
      WrapCellPointer =   0   'False
   End
   Begin Threed.SSFrame Frame 
      Height          =   1065
      Index           =   0
      Left            =   105
      TabIndex        =   1
      Top             =   1155
      Width           =   6735
      _version        =   65536
      _extentx        =   11880
      _extenty        =   1879
      _stockprops     =   14
      Begin VB.CommandButton Selection 
         Caption         =   "&Exit"
         Height          =   315
         HelpContextID   =   20200
         Index           =   0
         Left            =   5355
         TabIndex        =   7
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Add"
         Height          =   315
         HelpContextID   =   20200
         Index           =   1
         Left            =   1260
         TabIndex        =   6
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Delete"
         Height          =   315
         HelpContextID   =   20200
         Index           =   2
         Left            =   2625
         TabIndex        =   5
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Print"
         Height          =   315
         HelpContextID   =   20200
         Index           =   4
         Left            =   3990
         TabIndex        =   4
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Sort by"
         Height          =   315
         HelpContextID   =   20200
         Index           =   5
         Left            =   3990
         TabIndex        =   3
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Find"
         Height          =   315
         HelpContextID   =   20200
         Index           =   6
         Left            =   5355
         TabIndex        =   2
         Top             =   210
         Width           =   1275
      End
   End
End
Attribute VB_Name = "Products"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private poForm As FormObj
Private poGrid As GridObj


Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set poForm = Nothing
    Set Products = Nothing
End Sub


Private Sub Form_Load()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Load"

    Set poForm = New FormObj
    
    poForm.xInitialize Me

    poForm.xAddResizeObject Table.Name, FINDEX_NONE
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_STRETCH
    
    poForm.xAddResizeObject Frame(0).Name, 0
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_MOVE

    poForm.xAddResizeObject Selection(0).Name, FINDEX_ALL
    poForm.xAddStyle FRESIZE_X_MOVE

'   Bind the data control to the DBaseObj
    Set poGrid = New GridObj
    
    poGrid.xInitialize Me, Me.Table, App.Path & DATABASE_NAME, DBase
    poGrid.gsNotWhileEdit = Selection(0).Name
    Set poGrid.goVForm = frmVList
        
    poGrid.xAddTable "product", ""
    poGrid.gsSortFields = "'|' UPC | Description | Category | UnitCost | BulkUnitSize"
    poGrid.gsFindFields = "(2) '|' UPC | t | Category | l | UnitCost | n | BulkUnitSize | n"
    poGrid.giNumKeys = 3
    
    poGrid.gsValidationColumn = "UPC"
    
'   Setup the unique indeces
    poGrid.xAddIndex "UPC", True
    poGrid.gsIndexField = "UPC"
    
'   Setup the column validation rules

    poGrid.xAddColumn "UPC"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE
    poGrid.xAddRule VRULE_ISEXACT_LEN, 12

    poGrid.xAddColumn "Description"
    poGrid.xAddRule VRULE_ISMAX_LEN, 255

    poGrid.xAddColumn "Category", "Category"
    poGrid.xSetGridColList gtSystem.sCategory
    poGrid.gsValidList = ReturnValidCategories()
    poGrid.xAddRule VRULE_ISINLIST

    poGrid.xAddColumn "UnitCost"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISPOSITIVE

    poGrid.xAddColumn "BulkUnitSize"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE

    poGrid.xAddColumn "Category", "Units in"
    poGrid.xSetGridColList gtSystem.sBulkUnits
    poGrid.gsValidList = ReturnValidCategories()
    poGrid.xAddRule VRULE_ISINLIST

    poForm.xCenter

    Table.Editable = IsPermissible(PERMISSION_WAREHOUSE)
    Selection(1).Enabled = IsPermissible(PERMISSION_WAREHOUSE)
    Selection(2).Enabled = IsPermissible(PERMISSION_WAREHOUSE)
    Selection(4).Enabled = IsPermissible(PERMISSION_PRINTING)

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub Form_Resize()
    poForm.xResize
End Sub



Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Dim sBuffer$
    
    Select Case Index
    Case 1  'AddNew
        poGrid.xSort ""
        sBuffer = "(2) '|'"
        sBuffer = sBuffer & " Category | " & Format$(gtSystem.iCategory)
        poGrid.xAddNew sBuffer
        Exit Sub
    Case 2  'Delete
        goDBase.gsCurTable = "Inventory"
        If goDBase.xFind("UPC = '" & Format$(poGrid.xGet("UPC")) & "'") Then
            MsgBox "Sorry, you can't delete the product if it still exists in inventory."
            Exit Sub
        End If
    
        goDBase.gsCurTable = "Detail"
        If goDBase.xFind("UPC = '" & Format$(poGrid.xGet("UPC")) & "'") Then
            MsgBox "Sorry, you can't delete the product if there is an order detailing it."
            Exit Sub
        End If
    End Select
    
    If xSelection(poGrid, Selection(Index)) Then Unload Me

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub Table_EnterEdit()
    poGrid.xEnterEdit
End Sub

Private Sub Table_ExitEdit()
    poGrid.xExitEdit
End Sub


Private Sub Table_KeyPress(KeyAscii As Integer)
    poGrid.xSetKey KeyAscii
End Sub

Private Sub Table_Validate(Row As Long, riCol As Integer, rsValue As String, Cancel As Integer)
    Cancel = Not poGrid.xValidate(riCol, rsValue)
End Sub


