VERSION 4.00
Begin VB.Form Stores 
   Caption         =   "Stores"
   ClientHeight    =   2100
   ClientLeft      =   225
   ClientTop       =   4215
   ClientWidth     =   7050
   ControlBox      =   0   'False
   Height          =   2505
   Icon            =   "STORES.frx":0000
   Left            =   165
   LinkTopic       =   "Form10"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2100
   ScaleWidth      =   7050
   Top             =   3870
   Width           =   7170
   Begin VB.Data DBase 
      Connect         =   "Access"
      DatabaseName    =   ""
      Exclusive       =   0   'False
      Height          =   300
      Left            =   0
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   ""
      Top             =   0
      Visible         =   0   'False
      Width           =   1140
   End
   Begin VBX.TrueGrid Table 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BackColor       =   &H00C0C0C0&
      DataSource      =   "DBase"
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      HeadingHeight   =   1
      Height          =   750
      HelpContextID   =   8100
      HorzLines       =   2  '3D
      Layout          =   "STORES.frx":030A
      LayoutIndex     =   1
      Left            =   105
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   -1  'True
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   0
      Tag             =   "Table"
      Top             =   105
      UseBookmarks    =   -1  'True
      Width           =   6840
      WrapCellPointer =   0   'False
   End
   Begin Threed.SSFrame Frame 
      Height          =   1065
      Index           =   0
      Left            =   105
      TabIndex        =   1
      Top             =   945
      Width           =   6840
      _version        =   65536
      _extentx        =   12065
      _extenty        =   1879
      _stockprops     =   14
      Begin VB.CommandButton Selection 
         Caption         =   "&Exit"
         Height          =   315
         HelpContextID   =   20200
         Index           =   0
         Left            =   5460
         TabIndex        =   7
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Add"
         Height          =   315
         HelpContextID   =   20200
         Index           =   1
         Left            =   1365
         TabIndex        =   4
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Delete"
         Height          =   315
         HelpContextID   =   20200
         Index           =   2
         Left            =   2730
         TabIndex        =   5
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Print"
         Height          =   315
         HelpContextID   =   20200
         Index           =   4
         Left            =   4095
         TabIndex        =   6
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Sort by"
         Height          =   315
         HelpContextID   =   20200
         Index           =   3
         Left            =   4095
         TabIndex        =   2
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Find"
         Height          =   315
         HelpContextID   =   20200
         Index           =   5
         Left            =   5460
         TabIndex        =   3
         Top             =   210
         Width           =   1275
      End
   End
End
Attribute VB_Name = "Stores"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private poForm As FormObj
Private poGrid As GridObj

Private Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"
    
    poGrid.gsCurColumn = "Manager"
    goDBase.gsCurTable = "Employee"
    poGrid.xSetGridColList goDBase.xGetList("UserName", "EmployeeID")
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set poForm = Nothing
    Set Stores = Nothing
End Sub

Private Sub Form_Load()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Load"

    Set poForm = New FormObj
    
    poForm.xInitialize Me

    poForm.xAddResizeObject Table.Name, FINDEX_NONE
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_STRETCH
    
    poForm.xAddResizeObject Frame(0).Name, 0
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_MOVE

    poForm.xAddResizeObject Selection(0).Name, FINDEX_ALL
    poForm.xAddStyle FRESIZE_X_MOVE

'   Bind the data control to the DBaseObj
    Set poGrid = New GridObj
    
    poGrid.xInitialize Me, Me.Table, App.Path & DATABASE_NAME, DBase
    poGrid.gsNotWhileEdit = Selection(0).Name
        
    poGrid.xAddTable "store", ""
    poGrid.gsSortFields = "'|' StoreID | StoreName | Address | Manager | PhoneNumber"
    poGrid.gsFindFields = "(2) '|' StoreID | n | StoreName | t | Address | t | Manager | t | PhoneNumber | t"
    poGrid.giNumKeys = 3
    
    poGrid.xAddIndex "StoreID", True
    poGrid.gsIndexField = "storeID"
    
'   Setup the column validation rules

    poGrid.xAddColumn "StoreID"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE

    poGrid.xAddColumn "StoreName"
    poGrid.xAddRule VRULE_ISNOTNULL
    poGrid.xAddRule VRULE_ISMAX_LEN, 255
    
    poGrid.xAddColumn "Address"
    poGrid.xAddRule VRULE_ISMAX_LEN, 255

    poGrid.xAddColumn "Manager"
    goDBase.gsCurTable = "Employee"
    poGrid.xSetGridColList goDBase.xGetList("UserName", "EmployeeID")
    poGrid.xAddRule VRULE_ISINLIST

    poGrid.xAddColumn "PhoneNumber"
    poGrid.xAddRule VRULE_ISMAX_LEN, 255

    Table.Editable = IsPermissible(PERMISSION_STORES)
    Selection(1).Enabled = IsPermissible(PERMISSION_STORES)
    Selection(2).Enabled = IsPermissible(PERMISSION_STORES)
    Selection(4).Enabled = IsPermissible(PERMISSION_PRINTING)
    
    poForm.xCenter

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



Private Sub Form_Resize()
    poForm.xResize
End Sub




Private Sub Table_KeyPress(KeyAscii As Integer)
    poGrid.xSetKey KeyAscii
End Sub


Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Select Case Index
    Case 2  'Delete
        goDBase.gsCurTable = "Employee"
        If goDBase.xFind("storeID = " & Format$(poGrid.xGet("StoreID"))) Then
            MsgBox "Sorry, you can't delete the store if an employee exists that is working there."
            Exit Sub
        End If
    
        goDBase.gsCurTable = "Inventory"
        If goDBase.xFind("StoreID = " & Format$(poGrid.xGet("StoreID"))) Then
            MsgBox "Sorry, you can't delete the store if it still has inventory."
            Exit Sub
        End If
    
        goDBase.gsCurTable = "Orders"
        If goDBase.xFind("StoreID = " & Format$(poGrid.xGet("StoreID"))) Then
            MsgBox "Sorry, you can't delete the store if it still has orders."
            Exit Sub
        End If
    End Select
    
    If xSelection(poGrid, Selection(Index)) Then Unload Me

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub




Private Sub Table_EnterEdit()
    poGrid.xEnterEdit
End Sub
Private Sub Table_ExitEdit()
    poGrid.xExitEdit
End Sub



Private Sub Table_Validate(Row As Long, Col As Integer, Value As String, Cancel As Integer)
    Cancel = Not poGrid.xValidate(Col, Value)
End Sub


