VERSION 4.00
Begin VB.Form AutoOrder 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Auto Order"
   ClientHeight    =   2085
   ClientLeft      =   1500
   ClientTop       =   3285
   ClientWidth     =   4395
   ControlBox      =   0   'False
   Height          =   2490
   Left            =   1440
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2085
   ScaleWidth      =   4395
   ShowInTaskbar   =   0   'False
   Top             =   2940
   Width           =   4515
   Begin VB.TextBox Text 
      Height          =   315
      HelpContextID   =   10100
      Index           =   2
      Left            =   1365
      Locked          =   -1  'True
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   525
      Width           =   2955
   End
   Begin VB.Timer Timer 
      Index           =   0
      Interval        =   1000
      Left            =   105
      Top             =   1155
   End
   Begin VB.TextBox Text 
      Height          =   315
      HelpContextID   =   10100
      Index           =   1
      Left            =   1365
      Locked          =   -1  'True
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   945
      Width           =   2955
   End
   Begin VB.TextBox Text 
      Height          =   315
      HelpContextID   =   10100
      Index           =   0
      Left            =   1365
      TabIndex        =   0
      Top             =   105
      Width           =   2955
   End
   Begin Threed.SSFrame Frame 
      Height          =   645
      Index           =   0
      Left            =   105
      TabIndex        =   4
      Top             =   1365
      Width           =   4215
      _version        =   65536
      _extentx        =   7435
      _extenty        =   1138
      _stockprops     =   14
      Begin VB.CommandButton Selection 
         Caption         =   "&Accept"
         Default         =   -1  'True
         Height          =   315
         HelpContextID   =   20200
         Index           =   1
         Left            =   1470
         TabIndex        =   2
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Order Now"
         Height          =   315
         HelpContextID   =   20200
         Index           =   2
         Left            =   105
         TabIndex        =   1
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Exit"
         Height          =   315
         HelpContextID   =   20200
         Index           =   0
         Left            =   2835
         TabIndex        =   3
         Top             =   210
         Width           =   1275
      End
   End
   Begin VB.Label Label 
      BackStyle       =   0  'Transparent
      Caption         =   "Last AutoOrder:"
      Height          =   255
      Index           =   2
      Left            =   105
      TabIndex        =   9
      Top             =   555
      Width           =   1170
   End
   Begin VB.Label Label 
      BackStyle       =   0  'Transparent
      Caption         =   "Current Time:"
      Height          =   255
      Index           =   1
      Left            =   105
      TabIndex        =   7
      Top             =   945
      Width           =   1170
   End
   Begin VB.Label Label 
      BackStyle       =   0  'Transparent
      Caption         =   "Ordering Time:"
      Height          =   255
      Index           =   0
      Left            =   105
      TabIndex        =   5
      Top             =   135
      Width           =   1170
   End
End
Attribute VB_Name = "AutoOrder"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private pbShowFormUsed As Boolean
Private pbNotInitialization As Boolean
Private Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"

    If pbNotInitialization Then Exit Sub
    pbNotInitialization = True
    
    If Not pbShowFormUsed Then
        ExitProg sCurrentRoutine, "ShowForm was not used to create AutoOrder."
    End If

    Text(0).Text = Format$(CDate(goIni.xGet("General", "OrderTime", Format$(Now))))
    Text(2).Text = Format$(CDate(goIni.xGet("General", "LastOrder", Format$(Date))))

'   Center the form on the screen
    Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

'   ShowFOrm
'   PURPOSE:
'       - This routine sets up the form before it is shown on screen
'   PARAMETERS:
'       - DBase (DBaseObj)
'           - The database that is controlling the queried table
'       - TableName (string)
'           - The name of the table to query in this database object
'   RETURNS:
'       - None
Public Sub ShowForm()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".ShowForm"
    
    pbShowFormUsed = True
    
'   Load the form
    AutoOrder.Show
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



Private Sub Form_Unload(Cancel As Integer)
    Set AutoOrder = Nothing
End Sub


Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Dim iOrderNumber%
    
    Select Case Index
    Case 0  'Exit
        Unload Me
    Case 1  'Accept
'       Accept changes to the order time
        If IsDate(Text(0).Text) Then
            goIni.xSet "General", "OrderTime", Text(0).Text
            Unload Me
        Else
            MsgBox "Sorry, but the input given can not be read as time."
            Text(0).SetFocus
        End If
    Case 2  'Order Now
'       Create an auto order immediately
        iOrderNumber = AutoOrderIt()
        If (iOrderNumber <> -1) Then
            Details.ShowForm gtSystem.iStoreID, iOrderNumber
        Else
            MsgBox "Sorry nothing to order at the moment."
        End If
        Unload Me
    End Select

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Timer_Timer(Index As Integer)
    Text(1).Text = Format$(Now)
End Sub


