VERSION 4.00
Begin VB.Form Details 
   Caption         =   "Details (Order #, Date)"
   ClientHeight    =   1680
   ClientLeft      =   975
   ClientTop       =   2805
   ClientWidth     =   7005
   ControlBox      =   0   'False
   Height          =   2085
   Icon            =   "DETAILS.frx":0000
   Left            =   915
   LinkTopic       =   "Form4"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   112
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   467
   Top             =   2460
   Visible         =   0   'False
   Width           =   7125
   Begin VB.Data DBase 
      Connect         =   "Access"
      DatabaseName    =   ""
      Exclusive       =   0   'False
      Height          =   300
      Left            =   315
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   ""
      Top             =   1155
      Visible         =   0   'False
      Width           =   1140
   End
   Begin VBX.TrueGrid Table 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BackColor       =   &H00C0C0C0&
      DataSource      =   "DBase"
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      HeadingHeight   =   1
      Height          =   750
      HelpContextID   =   8100
      HorzLines       =   2  '3D
      Layout          =   "DETAILS.frx":030A
      LayoutIndex     =   1
      Left            =   105
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   -1  'True
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   0
      Tag             =   "Table"
      Top             =   105
      UseBookmarks    =   -1  'True
      Width           =   6840
      WrapCellPointer =   0   'False
   End
   Begin Threed.SSFrame Frame 
      Height          =   645
      Index           =   0
      Left            =   105
      TabIndex        =   1
      Top             =   945
      Width           =   6840
      _version        =   65536
      _extentx        =   12065
      _extenty        =   1138
      _stockprops     =   14
      Begin VB.CommandButton Selection 
         Cancel          =   -1  'True
         Caption         =   "&Find"
         Height          =   315
         HelpContextID   =   20200
         Index           =   2
         Left            =   4095
         TabIndex        =   4
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Sort by"
         Height          =   315
         HelpContextID   =   20200
         Index           =   1
         Left            =   2730
         TabIndex        =   3
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Exit"
         Height          =   315
         HelpContextID   =   20200
         Index           =   0
         Left            =   5460
         TabIndex        =   2
         Top             =   210
         Width           =   1275
      End
   End
End
Attribute VB_Name = "Details"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private poForm As FormObj
Private poGrid As GridObj

Private pbShowFormUsed As Boolean           ' Whether the ShowForm routine was used
Private pbNotInitialization As Boolean      ' Whether the initialization is complete

Private piOrderNumber%                      ' The number of the order being displayed
Private piStoreID%

Private plOldQuantity&
Private piColumn%
Private piRow%
Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set poForm = Nothing
    Set Details = Nothing
End Sub

Private Sub Table_EnterEdit()
    plOldQuantity = Val(Table.ColumnText(Table.ColumnIndex))
    piColumn = Table.ColumnIndex
    piRow = Table.RowIndex
    
    poGrid.xEnterEdit
End Sub
Private Sub Table_ExitEdit()
    poGrid.xExitEdit
    
    Dim lNewQuantity&, lChange&
    Dim sBuffer$, sUPC$
    Dim lQuantity&

    Table.RowIndex = piRow
    lNewQuantity = Val(Table.ColumnText(piColumn))
    
    If (lNewQuantity <> plOldQuantity) Then
        lChange = lNewQuantity - plOldQuantity
        If (MsgBox("You are just about to change the current product in inventory by " & Format$(lChange) & " units.  Continue?", vbYesNo) = vbNo) Then
            Table.ColumnText(piColumn) = Format$(plOldQuantity)
        Else
            sUPC = Format$(poGrid.xGet("Product.UPC"))
            
            goDBase.gsCurTable = "Inventory"
            If goDBase.xFind("UPC = '" & sUPC & "'") Then
                lQuantity = Val(goDBase.xGet("Quantity"))
                If ((lQuantity < Abs(lChange)) And (lChange < 0)) Then
                    If (MsgBox("A change of " & Format$(lChange) & " units will result in a negative inventory.  Continue?", vbYesNo) = vbNo) Then
                        Table.ColumnText(piColumn) = Format$(plOldQuantity)
                        Exit Sub
                    End If
                End If
            Else
                If (lChange < 0) Then
                    If (MsgBox("A change of " & Format$(lChange) & " units will result in a negative inventory.  Continue?", vbYesNo) = vbNo) Then
                        Table.ColumnText(piColumn) = Format$(plOldQuantity)
                        Exit Sub
                    End If
                End If
            End If
            
            UpdateDetail sUPC, lChange
        End If
    End If
End Sub

Public Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"

    If pbNotInitialization Then Exit Sub
    pbNotInitialization = True
    
    Dim sStoreName$
    
    If Not pbShowFormUsed Then
        ExitProg sCurrentRoutine, "ShowForm was not used to display Details."
    End If
    
    Set poForm = New FormObj
    
    poForm.xInitialize Me
    
    poForm.xAddResizeObject Table.Name, FINDEX_NONE
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_STRETCH
    
    poForm.xAddResizeObject Frame(0).Name, 0
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_MOVE

    poForm.xAddResizeObject Selection(0).Name, FINDEX_ALL
    poForm.xAddStyle FRESIZE_X_MOVE
    
    goDBase.gsCurTable = "Store"
    If goDBase.xFind("StoreID = " & Format$(piStoreID)) Then sStoreName = Format$(goDBase.xGet("StoreName"))
    
    goDBase.gsCurTable = "Orders"
    If Not goDBase.xFind("StoreID = " & Format$(piStoreID) & " AND OrderNumber = " & Format$(piOrderNumber)) Then
        ExitProg sCurrentRoutine, "Unable to locate the order in the database."
    End If
    
    Me.Caption = "Details (" & sStoreName & " #" & Format$(piOrderNumber) & ", " & Format$(CDate(goDBase.xGet("DateOrdered"))) & ")"

    If (Val(goDBase.xGet("Status")) = STATUS_PENDING) Then
        MsgBox "Sorry, Until this order is filled, details are read-only."
        Table.Enabled = False
    End If
    
'   Bind the data control to the DBaseObj
    Set poGrid = New GridObj
    
    poGrid.xInitialize Me, Me.Table, App.Path & DATABASE_NAME, DBase
    poGrid.gsNotWhileEdit = Selection(0).Name
    
    poGrid.xAddTable "detail", "StoreID = " & Format$(piStoreID) & " AND OrderNumber = " & Format$(piOrderNumber), "SELECT * FROM Product RIGHT JOIN Detail ON Product.UPC = Detail.UPC"
    poGrid.gsSortFields = "'|' Product.UPC | Description | Category | AmtOrdered | AmtReceived"
    poGrid.gsFindFields = "(2) '|' Product.UPC | t | Category | l | AmtOrdered | n | AmtReceived | n"
    poGrid.giNumKeys = 3
        
'   Setup the column validation rules
    poGrid.xAddColumn "Category"
    poGrid.xSetGridColList gtSystem.sCategory
    poGrid.xAddRule VRULE_ISINLIST
    
    poGrid.xAddColumn "AmtReceived"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE
    
    goDBase.gsCurTable = "Orders"
    goDBase.xFind ("storeid = " & Format$(piStoreID) & " AND ordernumber = " & Format$(piOrderNumber))
    
    Select Case Val(goDBase.xGet("status"))
    Case STATUS_PENDING
        Table.Editable = False
    Case Else
        Table.Editable = IsPermissible(PERMISSION_CHANGEORDERS)
    End Select
    
    poForm.xCenter
    
    Me.Visible = True
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_Resize()
    poForm.xResize
End Sub

Private Sub Table_KeyPress(KeyAscii As Integer)
    poGrid.xSetKey KeyAscii
End Sub






'   Table_Validate
'   PURPOSE:
'       - Makes sure that all the data entering the database is proper
'   PARAMETERS:
'       - Row (long)
'           - The row the change is being made on
'       - Column (integer)
'           - The column the change is being made in
'       - Value (string)
'           - The new value
'       - Cancel (integer)
'           - Whether or not to reenter or exit edit mode
'   RETURNS:
'       - Cancel (integer)
'           - TRUE : Cancel the update and return to edit mode
'           - FALSE: Update the database and exit edit mode
Private Sub Table_Validate(Row As Long, riCol As Integer, rsValue As String, Cancel As Integer)
    Cancel = Not poGrid.xValidate(riCol, rsValue)
End Sub

Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
        
    Dim iStatus%
        
    If xSelection(poGrid, Selection(Index)) Then
        goDBase.gsCurTable = "Orders"
        If goDBase.xFind("storeid = " & Format$(piStoreID) & " AND ordernumber = " & Format$(piOrderNumber)) Then
            iStatus = Val(goDBase.xGet("status"))
'           Check to see if there are any outstanding prodcts in this order still
            If Not poGrid.xFind("AmtReceived < AmtOrdered") Then
'               All goods have been received
                If (iStatus <> STATUS_RECEIVED) Then
                    If (MsgBox("It appears all goods have been received in this shipment, mark order 'Received'?", vbYesNo) = vbYes) Then
                        goDBase.xSet "Status", STATUS_RECEIVED
                        goDBase.xSet "DateCompleted", Now
                    End If
                End If
            ElseIf Not poGrid.xFind("AmtReceived > 0") Then
'               No goods AT ALL have been received
                If ((iStatus <> STATUS_FILLED) And (iStatus <> STATUS_PENDING)) Then
                    If (MsgBox("It appears that none of the goods have arrived, mark order 'Filled' for the moment?", vbYesNo) = vbYes) Then
                        goDBase.xSet "Status", STATUS_FILLED
                    End If
                End If
            Else
'               Some goods have been received, but not all of them
                If (iStatus <> STATUS_INCOMPLETE) Then
                    If (MsgBox("It appears at least one of the goods has not completely arrived, mark order 'Incomplete' for the moment?", vbYesNo) = vbYes) Then
                        goDBase.xSet "Status", STATUS_INCOMPLETE
                    End If
                End If
            End If
        End If

        Unload Me
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub






'   ShowForm
'   PURPOSE:
'       - Passes the required information to the Details screen without the
'         use of global variables
'   PARAMETERS:
'       - StoreID (integer)
'           - The unqiue ID of the current store
'       - OrderNumber (integer)
'           - The unique number of the order being displayed in Details
'   RETURNS:
'       - None
Public Sub ShowForm(riStoreID%, riOrderNumber%)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".ShowForm"

    piOrderNumber = riOrderNumber
    piStoreID = riStoreID

    pbShowFormUsed = True
    
    Call Details.Form_Activate

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub
