VERSION 4.00
Begin VB.Form Inventory 
   Caption         =   "Inventory"
   ClientHeight    =   2400
   ClientLeft      =   2760
   ClientTop       =   4230
   ClientWidth     =   7020
   ControlBox      =   0   'False
   Height          =   2805
   Icon            =   "INVNTORY.frx":0000
   Left            =   2700
   LinkTopic       =   "Form10"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2400
   ScaleWidth      =   7020
   Top             =   3885
   Width           =   7140
   Begin VB.Data DBase 
      Connect         =   "Access"
      DatabaseName    =   ""
      Exclusive       =   0   'False
      Height          =   300
      Left            =   1785
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   ""
      Top             =   1155
      Visible         =   0   'False
      Width           =   1140
   End
   Begin VBX.TrueGrid Table 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BackColor       =   &H00C0C0C0&
      DataSource      =   "DBase"
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      HeadingHeight   =   1
      Height          =   1065
      HelpContextID   =   8100
      HorzLines       =   2  '3D
      Layout          =   "INVNTORY.frx":030A
      LayoutIndex     =   1
      Left            =   105
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   0   'False
      SplitTabMode    =   1  'Tab across splits
      TabCapture      =   0   'False
      TabIndex        =   0
      Tag             =   "Table"
      Top             =   105
      UseBookmarks    =   -1  'True
      Width           =   6840
      WrapCellPointer =   0   'False
   End
   Begin Threed.SSFrame Frame 
      Height          =   1065
      Index           =   0
      Left            =   105
      TabIndex        =   1
      Top             =   1260
      Width           =   6840
      _version        =   65536
      _extentx        =   12065
      _extenty        =   1879
      _stockprops     =   14
      Begin VB.CommandButton Selection 
         Caption         =   "&Exit"
         Height          =   315
         HelpContextID   =   20200
         Index           =   0
         Left            =   5460
         TabIndex        =   5
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Print"
         Height          =   315
         HelpContextID   =   20200
         Index           =   4
         Left            =   4095
         TabIndex        =   4
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Sort by"
         Height          =   315
         HelpContextID   =   20200
         Index           =   2
         Left            =   4095
         TabIndex        =   3
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Find"
         Height          =   315
         HelpContextID   =   20200
         Index           =   1
         Left            =   5460
         TabIndex        =   2
         Top             =   210
         Width           =   1275
      End
   End
End
Attribute VB_Name = "Inventory"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private poForm As FormObj
Private poGrid As GridObj

Private Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"

    poGrid.gsCurColumn = "StoreID"
    goDBase.gsCurTable = "Store"
    poGrid.xSetGridColList goDBase.xGetList("StoreName", "StoreID")
    
    poGrid.xReQuery

    If Not IsPermissible(PERMISSION_STORES) Then
        goDBase.gsCurTable = "Store"
        If goDBase.xFind("StoreID = " & Format$(gtSystem.iStoreID)) Then Me.Caption = "Inventory of " & Format$(goDBase.xGet("StoreName"))
    End If
        
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set poForm = Nothing
    Set Inventory = Nothing
End Sub

Private Sub Form_Load()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Load"

    Set poForm = New FormObj
    
    poForm.xInitialize Me

    poForm.xAddResizeObject Table.Name, FINDEX_NONE
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_STRETCH
    
    poForm.xAddResizeObject Frame(0).Name, 0
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_MOVE

    poForm.xAddResizeObject Selection(0).Name, FINDEX_ALL
    poForm.xAddStyle FRESIZE_X_MOVE

'   Bind the data control to the DBaseObj
    Set poGrid = New GridObj
    
    poGrid.xInitialize Me, Me.Table, App.Path & DATABASE_NAME, DBase
    poGrid.gsNotWhileEdit = Selection(0).Name
    
    If IsPermissible(PERMISSION_STORES) Then
        poGrid.xAddTable "inventory", "", "SELECT * FROM Product RIGHT JOIN Inventory ON Product.UPC = Inventory.UPC"
        poGrid.gsSortFields = "'|' StoreID | Product.UPC | Description | Category | Quantity | OnOrder | Ordering | AlertLevel | RestockQty"
        poGrid.gsFindFields = "(2) '|' StoreID | l | Product.UPC | t | Category | l | Quantity | n | OnOrder | n | Ordering | l | AlertLevel | n | RestockQty | n"
        poGrid.giNumKeys = 3
    Else
        poGrid.xAddTable "inventory", "StoreID = " & Format$(gtSystem.iStoreID), "SELECT * FROM Product RIGHT JOIN Inventory ON Product.UPC = Inventory.UPC"
        poGrid.gsSortFields = "'|' Product.UPC | Description | Category | Quantity | OnOrder | Ordering | AlertLevel | RestockQty"
        poGrid.gsFindFields = "(2) '|' Product.UPC | t | Category | l | Quantity | n | OnOrder | n | Ordering | l | AlertLevel | n | RestockQty | n"
        poGrid.giNumKeys = 3
    
        Table.SplitIndex = 1
        poGrid.xVisible "StoreID", False
    
        goDBase.gsCurTable = "Store"
        If goDBase.xFind("StoreID = " & Format$(gtSystem.iStoreID)) Then Me.Caption = "Inventory of " & Format$(goDBase.xGet("StoreName"))
    End If

'   Setup the column validation rules
    poGrid.xAddColumn "StoreID"
    goDBase.gsCurTable = "Store"
    poGrid.xSetGridColList goDBase.xGetList("StoreName", "StoreID")
    poGrid.xAddRule VRULE_ISINLIST
    
    poGrid.xAddColumn "Product.UPC"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE
    poGrid.xAddRule VRULE_ISEXACT_LEN, 12

    poGrid.xAddColumn "Description"
    poGrid.xAddRule VRULE_ISMAX_LEN, 255

    poGrid.xAddColumn "Category"
    poGrid.xSetGridColList gtSystem.sCategory
    poGrid.gsValidList = ReturnValidCategories()
    poGrid.xAddRule VRULE_ISINLIST
    
    poGrid.xAddColumn "Quantity"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISMIN_VAL, 0
    
    poGrid.xAddColumn "Ordering"
    poGrid.xSetGridColList gtSystem.sOrdering
    poGrid.xAddRule VRULE_ISINLIST
    
    poGrid.xAddColumn "AlertLevel"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE
    
    poGrid.xAddColumn "RestockQty"
    poGrid.xAddRule VRULE_ISNUMERIC
    poGrid.xAddRule VRULE_ISNOTDECIMAL
    poGrid.xAddRule VRULE_ISPOSITIVE
        
    Table.Editable = IsPermissible(PERMISSION_INVENTORY)
    Selection(4).Enabled = IsPermissible(PERMISSION_PRINTING)
    
    poForm.xCenter
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub Table_EnterEdit()
    poGrid.xEnterEdit
End Sub
Private Sub Table_ExitEdit()
    poGrid.xExitEdit
End Sub

Private Sub Form_Resize()
    poForm.xResize
End Sub


Private Sub Table_KeyPress(KeyAscii As Integer)
    poGrid.xSetKey KeyAscii
End Sub


Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    If xSelection(poGrid, Selection(Index)) Then Unload Me

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



'   Table_Validate
'   PURPOSE:
'       - Makes sure that all the data entering the database is proper
'   PARAMETERS:
'       - Row (long)
'           - The row the change is being made on
'       - Column (integer)
'           - The column the change is being made in
'       - Value (string)
'           - The new value
'       - Cancel (integer)
'           - Whether or not to reenter or exit edit mode
'   RETURNS:
'       - Cancel (integer)
'           - TRUE : Cancel the update and return to edit mode
'           - FALSE: Update the database and exit edit mode
Private Sub Table_Validate(Row As Long, riCol As Integer, rsValue As String, Cancel As Integer)
    Cancel = Not poGrid.xValidate(riCol, rsValue)
End Sub



