VERSION 4.00
Begin VB.Form Orders 
   Caption         =   "Orders"
   ClientHeight    =   2400
   ClientLeft      =   1410
   ClientTop       =   4080
   ClientWidth     =   7020
   ControlBox      =   0   'False
   Height          =   2805
   Icon            =   "ORDERS.frx":0000
   Left            =   1350
   LinkTopic       =   "Form10"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2400
   ScaleWidth      =   7020
   Top             =   3735
   Width           =   7140
   Begin VB.Data DBase 
      Connect         =   "Access"
      DatabaseName    =   ""
      Exclusive       =   0   'False
      Height          =   300
      Left            =   0
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   ""
      Top             =   0
      Visible         =   0   'False
      Width           =   1140
   End
   Begin VBX.TrueGrid Table 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BackColor       =   &H00C0C0C0&
      DataSource      =   "DBase"
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      HeadingHeight   =   1
      Height          =   1065
      HelpContextID   =   8100
      HorzLines       =   2  '3D
      Layout          =   "ORDERS.frx":030A
      LayoutIndex     =   1
      Left            =   105
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   0   'False
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   0
      Tag             =   "Table"
      Top             =   105
      UseBookmarks    =   -1  'True
      Width           =   6840
      WrapCellPointer =   0   'False
   End
   Begin Threed.SSFrame Frame 
      Height          =   1065
      Index           =   0
      Left            =   105
      TabIndex        =   1
      Top             =   1260
      Width           =   6840
      _version        =   65536
      _extentx        =   12065
      _extenty        =   1879
      _stockprops     =   14
      Begin VB.CommandButton Selection 
         Caption         =   "&Received"
         Height          =   315
         HelpContextID   =   20200
         Index           =   7
         Left            =   2730
         TabIndex        =   9
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Exit"
         Height          =   315
         HelpContextID   =   20200
         Index           =   0
         Left            =   5460
         TabIndex        =   8
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Manual Order"
         Height          =   315
         HelpContextID   =   20200
         Index           =   1
         Left            =   105
         TabIndex        =   7
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Details"
         Height          =   315
         HelpContextID   =   20200
         Index           =   2
         Left            =   2730
         TabIndex        =   6
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Sort by"
         Height          =   315
         HelpContextID   =   20200
         Index           =   3
         Left            =   4095
         TabIndex        =   5
         Top             =   210
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Print"
         Height          =   315
         HelpContextID   =   20200
         Index           =   4
         Left            =   4095
         TabIndex        =   4
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Auto Order"
         Height          =   315
         HelpContextID   =   20200
         Index           =   5
         Left            =   105
         TabIndex        =   3
         Top             =   630
         Width           =   1275
      End
      Begin VB.CommandButton Selection 
         Caption         =   "&Find"
         Height          =   315
         HelpContextID   =   20200
         Index           =   6
         Left            =   5460
         TabIndex        =   2
         Top             =   210
         Width           =   1275
      End
   End
End
Attribute VB_Name = "Orders"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private poForm As FormObj
Private poGrid As GridObj


Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set poForm = Nothing
    Set Orders = Nothing
End Sub

Private Sub Table_EnterEdit()
    poGrid.xEnterEdit
End Sub
Private Sub Table_ExitEdit()
    poGrid.xExitEdit
End Sub

Private Sub Form_Load()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Load"

    Set poForm = New FormObj
    
    poForm.xInitialize Me

    poForm.xAddResizeObject Table.Name, FINDEX_NONE
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_STRETCH
    
    poForm.xAddResizeObject Frame(0).Name, 0
    poForm.xAddStyle FRESIZE_X_STRETCH
    poForm.xAddStyle FRESIZE_Y_MOVE

    poForm.xAddResizeObject Selection(0).Name, FINDEX_ALL
    poForm.xAddStyle FRESIZE_X_MOVE

'   Bind the data control to the DBaseObj
    Set poGrid = New GridObj
    
    poGrid.xInitialize Me, Me.Table, App.Path & DATABASE_NAME, DBase
    poGrid.gsNotWhileEdit = Selection(0).Name
    
    If IsPermissible(PERMISSION_STORES) Then
        poGrid.xAddTable "orders", ""
        poGrid.gsSortFields = "'|' OrderNumber | StoreID | EmployeeID | DateOrdered | DateCompleted | Status"
        poGrid.gsFindFields = "(2) '|' OrderNumber | n | StoreID | l | EmployeeID | l | DateOrdered | t | DateCompleted | t | Status | l"
        poGrid.giNumKeys = 3
    Else
        poGrid.xAddTable "orders", "StoreID = " & Format$(gtSystem.iStoreID)
        poGrid.gsSortFields = "'|' OrderNumber | EmployeeID | DateOrdered | DateCompleted  | Status"
        poGrid.gsFindFields = "(2) '|' OrderNumber | n | EmployeeID | l | DateOrdered | t | DateCompleted | t | Status | l"
        poGrid.giNumKeys = 3
        
        Table.SplitIndex = 1
        poGrid.xVisible "StoreID", False
        
        goDBase.gsCurTable = "Store"
        If goDBase.xFind("StoreID = " & Format$(gtSystem.iStoreID)) Then Me.Caption = "Orders of " & Format$(goDBase.xGet("StoreName"))
    End If
        
    If IsPermissible(PERMISSION_WAREHOUSE) Then
        Selection(7).Caption = "&Filled"
    Else
        Selection(7).Caption = "&Received"
    End If

'   Setup the column validation rules
    poGrid.xAddColumn "StoreID"
    goDBase.gsCurTable = "Store"
    poGrid.xSetGridColList goDBase.xGetList("StoreName", "StoreID")

    poGrid.xAddColumn "Status"
    poGrid.xSetGridColList gtSystem.sStatus
    poGrid.xAddRule VRULE_ISINLIST

    poGrid.xAddColumn "EmployeeID"
    goDBase.gsCurTable = "Employee"
    poGrid.xSetGridColList goDBase.xGetList("UserName", "EmployeeID") & " | <auto> | -1"
    
    poGrid.xAddColumn "DateOrdered"
    poGrid.xAddRule VRULE_ISDATE

    poGrid.xAddColumn "DateCompleted"
    poGrid.xAddRule VRULE_ISDATE

    Table.Editable = IsPermissible(PERMISSION_CHANGEORDERS)
    Selection(1).Enabled = IsPermissible(PERMISSION_MANUALORDER)
    Selection(5).Enabled = IsPermissible(PERMISSION_AUTOORDER)
    Selection(4).Enabled = IsPermissible(PERMISSION_PRINTING)

    poForm.xCenter
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_Resize()
    poForm.xResize
End Sub



Private Sub Table_KeyPress(KeyAscii As Integer)
    poGrid.xSetKey KeyAscii
End Sub


Private Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"
    
    poGrid.gsCurColumn = "StoreID"
    goDBase.gsCurTable = "Store"
    poGrid.xSetGridColList goDBase.xGetList("StoreName", "StoreID")
    
    poGrid.gsCurColumn = "EmployeeID"
    goDBase.gsCurTable = "Employee"
    poGrid.xSetGridColList goDBase.xGetList("UserName", "EmployeeID") & " | <auto> | -1"
                   
    poGrid.xReQuery
            
    If Not IsPermissible(PERMISSION_STORES) Then
        goDBase.gsCurTable = "Store"
        If goDBase.xFind("StoreID = " & Format$(gtSystem.iStoreID)) Then Me.Caption = "Orders of " & Format$(goDBase.xGet("StoreName"))
    End If
            
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Dim tDBase As DBaseObj
    Dim sUPC$, lChange&
    
    Select Case Index
    Case 1  'Manual Order
        NewOrder.Show
    Case 2  'Details
        If (Table.RowIndex > 0) And (poGrid.giNumRecords > 0) Then
            Details.ShowForm Val(poGrid.xGet("StoreID")), Val(poGrid.xGet("OrderNumber"))
        End If
    Case 5  'Auto Order
        AutoOrder.ShowForm
    Case 7  'Set Set/Received
        If (Val(poGrid.xGet("Status")) = STATUS_PENDING) Then
'           Set to sent
            If (MsgBox("Are you sure you want to set this order to 'Filled'?", vbYesNo) = vbYes) Then
                poGrid.xSet "Status", STATUS_FILLED
                
                If IsPermissible(PERMISSION_CHANGEORDERS) Then
                    Selection(7).Caption = "&Received"
                Else
                    Selection(7).Enabled = False
                End If
            End If
        Else
'           Set to received
            If (MsgBox("Are you sure you want to set this order to 'Received'?", vbYesNo) = vbYes) Then
                poGrid.xSet "Status", STATUS_RECEIVED
                poGrid.xSet "DateCompleted", Now
                
                goDBase.gsCurTable = "Detail"
                goDBase.xMassFind "StoreID = " & Format$(poGrid.xGet("StoreID")) & " AND OrderNumber = " & Format$(poGrid.xGet("OrderNumber"))
                If goDBase.xMoveFirst Then
                    Do
                        sUPC = Format$(goDBase.xGet("UPC"))
                        lChange = Val(goDBase.xGet("AmtOrdered")) - Val(goDBase.xGet("AmtReceived"))
                        
                        UpdateDetail sUPC, lChange
                                                
                        goDBase.xSet "AmtReceived", Val(goDBase.xGet("AmtOrdered"))
                    Loop While goDBase.xMoveNext
                End If
                                
'               Reset after the MassFind
                goDBase.xMassFind ""
                                
                Selection(7).Enabled = False
            End If
        End If
    Case Else
        If xSelection(poGrid, Selection(Index)) Then Unload Me
    End Select

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub Table_RowChange()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Table_RowChange"
    
    If ((Table.RowIndex > 0) And (poGrid.giNumRecords > 0)) Then
        If (Val(poGrid.xGet("Status")) = STATUS_PENDING) Then
            Selection(7).Enabled = IsPermissible(PERMISSION_WAREHOUSE)
        Else
            Selection(7).Enabled = (Val(poGrid.xGet("Status")) = STATUS_FILLED) And IsPermissible(PERMISSION_CHANGEORDERS)
        End If
    Else
        Selection(7).Enabled = False
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


