VERSION 4.00
Begin VB.Form SortBy 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Sort By"
   ClientHeight    =   3975
   ClientLeft      =   3810
   ClientTop       =   2265
   ClientWidth     =   1905
   ControlBox      =   0   'False
   Height          =   4380
   KeyPreview      =   -1  'True
   Left            =   3750
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3975
   ScaleWidth      =   1905
   ShowInTaskbar   =   0   'False
   Top             =   1920
   Visible         =   0   'False
   Width           =   2025
   Begin VB.CommandButton Selection 
      Caption         =   "&Exit"
      Height          =   315
      HelpContextID   =   20200
      Index           =   1
      Left            =   315
      TabIndex        =   8
      Top             =   3570
      Width           =   1275
   End
   Begin VB.HScrollBar HScroll 
      Height          =   255
      Left            =   120
      Max             =   3
      Min             =   1
      TabIndex        =   6
      Top             =   2820
      Value           =   1
      Width           =   1680
   End
   Begin VB.CommandButton Selection 
      Caption         =   "&Sort"
      Default         =   -1  'True
      Height          =   315
      HelpContextID   =   20200
      Index           =   0
      Left            =   315
      TabIndex        =   0
      Top             =   3180
      Width           =   1275
   End
   Begin Threed.SSFrame Frame 
      Height          =   960
      Index           =   0
      Left            =   105
      TabIndex        =   1
      Top             =   1785
      Width           =   1695
      _version        =   65536
      _extentx        =   2990
      _extenty        =   1693
      _stockprops     =   14
      caption         =   "Sort Direction"
      Begin VB.OptionButton SortOption 
         Caption         =   "<default>"
         Height          =   330
         Index           =   0
         Left            =   210
         TabIndex        =   9
         Top             =   945
         Visible         =   0   'False
         Width           =   1170
      End
      Begin VB.OptionButton SortOption 
         Caption         =   "Descending"
         Height          =   330
         Index           =   2
         Left            =   105
         TabIndex        =   3
         Top             =   525
         Width           =   1485
      End
      Begin VB.OptionButton SortOption 
         Caption         =   "Ascending"
         Height          =   330
         Index           =   1
         Left            =   105
         TabIndex        =   2
         Top             =   210
         Width           =   1485
      End
   End
   Begin Threed.SSFrame Frame 
      Height          =   645
      Index           =   1
      Left            =   105
      TabIndex        =   4
      Top             =   420
      Width           =   1695
      _version        =   65536
      _extentx        =   2990
      _extenty        =   1138
      _stockprops     =   14
      caption         =   "Sort Field"
      Begin VB.OptionButton Option 
         Caption         =   "<default>"
         Height          =   330
         Index           =   0
         Left            =   105
         TabIndex        =   5
         Top             =   210
         Visible         =   0   'False
         Width           =   1485
      End
   End
   Begin VB.Label Label 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Primary"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   1
         weight          =   700
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   0
      Left            =   105
      TabIndex        =   7
      Top             =   120
      Width           =   1695
   End
End
Attribute VB_Name = "SortBy"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Const SORT_ASC% = 1
Private Const SORT_DESC% = 2

Private Type SortCriteriaTYPE
    sField As String                    ' The field name to sort using
    iDirection As Integer               ' Sort direction (SORT_ASC or SORT_DESC)
End Type

Private ptaSortCriteria() As SortCriteriaTYPE

Private poGrid As GridObj               ' The grid object where the queried
Private poForm As New FormObj                                        ' table exists

Private pbShowFormUsed As Boolean       ' Whether ShowForm was used to load form

Private piNumOptions%                   ' Number of option boxes loaded
Private pbInitialization%
Private pbReInitializing%
'   Form_Activate
'   PURPOSE:
'       - Routine creates the required options to place on the screen
'       - Initializes all operating variables
'       - Displays the SortBy form on screen
'
'       - Assumes that ShowForm was used to show this form
'   PARAMETERS:
'       - None
'   RETURNS:
'       - None
Public Sub Form_Activate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"
    
    If Not pbInitialization Then
        pbInitialization = True
        pbReInitializing = True
        
        Dim n%
        Dim tReturn As ExtractObj: Set tReturn = New ExtractObj
        Dim sText$
        
        If Not pbShowFormUsed Then
            ExitProg sCurrentRoutine, "ShowForm was not used to create SortBy."
        End If
        
    '   Create the option buttons required
        tReturn.gsValue = poGrid.gsSortFields
    
        SortBy.Option(0).Left = (SortBy.Frame(0).Width - SortBy.Option(0).Width) / 2
        For n = 1 To tReturn.giNumValues
            If (n <> 1) Then
                Load SortBy.Option(n)
                SortBy.Option(n).Move SortBy.Option(n - 1).Left, SortBy.Option(n - 1).Top + SortBy.Option(n - 1).Height
            Else
                Load SortBy.Option(n)
                SortBy.Option(n).Move SortBy.Option(0).Left, SortBy.Option(0).Top
            End If
            SortBy.Option(n).Caption = tReturn.gsaList(1, n)
            SortBy.Option(n).Visible = True
        Next n
        SortBy.Option(0).Value = 1
        SortBy.SortOption(1).Value = 1
    
        SortBy.Frame(1).Height = SortBy.Option(0).Height * tReturn.giNumValues + 315
        SortBy.Frame(0).Top = SortBy.Frame(1).Top + SortBy.Frame(1).Height
        SortBy.HScroll.Top = SortBy.Frame(0).Top + SortBy.Frame(0).Height + 75
    
        SortBy.Selection(0).Top = SortBy.HScroll.Top + SortBy.HScroll.Height + 75
        SortBy.Selection(1).Top = SortBy.Selection(0).Top + SortBy.Selection(0).Height + 75
    
        Me.Height = (Me.Height - Me.ScaleHeight) + SortBy.Selection(1).Top + SortBy.Selection(1).Height + 75
    
        If (poGrid.giNumKeys = 0) Then
            MsgBox "Sorry, but since NumKeys is 0, you can't sort on this table."
            Unload Me
            Exit Sub
        End If

'       Set up the Criteria listing
        ReDim ptaSortCriteria(1 To poGrid.giNumKeys) As SortCriteriaTYPE
    
'       Set the Scroll bar
        SortBy.HScroll.Min = 1
        SortBy.HScroll.Max = poGrid.giNumKeys
        SortBy.HScroll.Value = 1
    
'       Center the form on the screen
        Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
    
'       Set up the old sort information (if available from SQL statement)
'       Assumes that the proper notation was used

        sText = poGrid.gsSortCriteria
        n = 1
        Do While (sText <> "")
            If (InStr(sText, "[") = 0) Or (InStr(sText, "]") = 0) Then Exit Do
            
            ptaSortCriteria(n).sField = Trim$(Slice$(sText, InStr(sText, "[") + 1, InStr(sText, "]") - 1))
            sText = Mid$(sText$, InStr(sText, "]") + 1)
            
            If (InStr(sText, ",") <> 0) Then
                Select Case LCase$(Trim$(Left$(sText, InStr(sText, ",") - 1)))
                Case "asc"
                    ptaSortCriteria(n).iDirection = SORT_ASC
                Case "desc"
                    ptaSortCriteria(n).iDirection = SORT_DESC
                End Select
                
                sText = Mid$(sText$, InStr(sText, ",") + 1)
            Else
                Select Case LCase$(Trim$(sText))
                Case "asc"
                    ptaSortCriteria(n).iDirection = SORT_ASC
                Case "desc"
                    ptaSortCriteria(n).iDirection = SORT_DESC
                End Select
                sText = ""
            End If
            
            n = n + 1
        Loop
   
'       Setup the first sort on screen
        For n = 1 To tReturn.giNumValues
            If (LCase$(ptaSortCriteria(1).sField) = LCase$(tReturn.gsaList(1, n))) Then
                SortBy.Option(n).Value = 1
            End If
        Next n

        If (ptaSortCriteria(1).iDirection = 0) Then ptaSortCriteria(1).iDirection = SORT_ASC
        SortBy.SortOption(ptaSortCriteria(1).iDirection).Value = 1

        pbReInitializing = False

        poForm.xInitialize Me
        poForm.glScaleHeight = Me.ScaleHeight
        poForm.glScaleWidth = Me.ScaleWidth
        
        poForm.xCenter

        Me.Visible = True
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_Deactivate()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Deactivate"
    
    Unload Me
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Form_Activate"

'   Trap the DEL key
    Select Case KeyCode
    Case 46  'DEL
'       When the DEL key is pressed erase the current sort criteria
        SortBy.Option(0).Value = 1
        SortBy.SortOption(0).Value = 1
    End Select

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Form_Resize()
    If Not pbInitialization Then poForm.xResize
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set poGrid = Nothing
    Set SortBy = Nothing
End Sub


'
Private Sub HScroll_Change()
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".HScroll_Change"
    
    Dim n%, I%
    Dim tReturn As ExtractObj: Set tReturn = New ExtractObj
    
    Select Case HScroll.Value
    Case 1
        Label(0).Caption = "Primary"
    Case 2
        Label(0).Caption = "Secondary"
    Case 3
        Label(0).Caption = "Tertiary"
    Case Else
        Label(0).Caption = Format$(HScroll.Value) & "th"
    End Select

'   Set up the option buttons
    pbReInitializing = True
        
    tReturn.gsValue = poGrid.gsSortFields
    
    For I = 1 To tReturn.giNumValues
        SortBy.Option(I).Enabled = True
    Next I
    
    For n = 1 To HScroll.Value - 1
        For I = 1 To tReturn.giNumValues
            If (LCase$(ptaSortCriteria(n).sField) = LCase$(tReturn.gsaList(1, I))) Then
                SortBy.Option(I).Enabled = False
            End If
        Next I
    Next n

'   Set the values of this sort
    If (ptaSortCriteria(HScroll.Value).sField <> "") Then
        For I = 1 To tReturn.giNumValues
            If (LCase$(ptaSortCriteria(HScroll.Value).sField) = LCase$(tReturn.gsaList(1, I))) Then
                SortBy.Option(I).Value = 1
            End If
        Next I
    Else
        SortBy.Option(0).Value = 1
    End If

    SortBy.SortOption(ptaSortCriteria(HScroll.Value).iDirection).Value = 1

    pbReInitializing = False

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub



'   ShowFOrm
'   PURPOSE:
'       - This routine sets up the Sortby form before it is shown on screen
'   PARAMETERS:
'       - DBase (DBaseObj)
'           - The database that is controlling the queried table
'   RETURNS:
'       - None
Public Sub ShowForm(roGrid As GridObj)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".xShow"
    
'   Set a reference to the DBase object given
    Set poGrid = roGrid
    
    pbShowFormUsed = True
    
'   Load the form
    Call SortBy.Form_Activate
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

'   Option_Click
'   PURPOSE:
'       - Sets a new sort field for the current key
'       - Checks to see if that key is used anywhere AFTER the current key
'   PARAMETERS:
'       - Index (integer)
'           - Which sort field to use
'   RETURNS:
'       - None
Private Sub Option_Click(riIndex As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Option_Click"

    If pbReInitializing Then Exit Sub
    
    Dim n%, I%
    Dim tReturn As ExtractObj: Set tReturn = New ExtractObj

    tReturn.gsValue = poGrid.gsSortFields
        
    If (riIndex = 0) Then
        ptaSortCriteria(HScroll.Value).sField = ""
    Else
'       Check to see if any other key is already using that value
        For n = HScroll.Value + 1 To poGrid.giNumKeys
            If (LCase$(ptaSortCriteria(n).sField) = LCase$(tReturn.gsaList(1, riIndex))) Then
                MsgBox "Sorry that field is already being used by key #" & Format$(n) & "."
'               reset the value back to original value
                For I = 1 To tReturn.giNumValues
                    If (LCase$(ptaSortCriteria(HScroll.Value).sField) = LCase$(tReturn.gsaList(1, I))) Then
                        SortBy.Option(I).Value = 1
                    End If
                Next I
                Exit Sub
            End If
        Next n
        ptaSortCriteria(HScroll.Value).sField = tReturn.gsaList(1, riIndex)
    End If

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub

Private Sub Selection_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".Selection_Click"
    
    Dim sBuffer$
    Dim n%, iBlankFound%
    
    Select Case Index
    Case 0  ' Sort
'       Create the sort criteria string
'       Check for completely blank sort criteria
        iBlankFound = 0
        For n = 1 To UBound(ptaSortCriteria)
            If ((ptaSortCriteria(n).sField = "") And (ptaSortCriteria(n).iDirection = 0)) Then
                iBlankFound = n
            ElseIf (iBlankFound <> 0) Then
                MsgBox "Sort Criteria #" & Format$(iBlankFound) & " is missing."
                Exit Sub
            End If
        Next n
        
        sBuffer = ""
        For n = 1 To UBound(ptaSortCriteria)
            If ((ptaSortCriteria(n).sField = "") And (ptaSortCriteria(n).iDirection = 0)) Then
'               Assume this is the end of the sort criteria
                Exit For
            End If
            
            If (ptaSortCriteria(n).sField = "") Then
                MsgBox "Sort Criteria #" & Format$(n) & " is missing a sort field."
                Exit Sub
            End If
            
            sBuffer = sBuffer & "[" & ptaSortCriteria(n).sField & "]"
            
            If (ptaSortCriteria(n).iDirection = 0) Then
                MsgBox "Sort Criteria #" & Format$(n) & " is missing a sort direction."
                Exit Sub
            ElseIf (ptaSortCriteria(n).iDirection = SORT_ASC) Then
                sBuffer = sBuffer & " ASC"
            Else
                sBuffer = sBuffer & " DESC"
            End If
            sBuffer = sBuffer & ", "
        Next n
        
'       Cut off the final ", "
        sBuffer = Left$(sBuffer, Len(sBuffer) - 2)
        
        poGrid.xSort sBuffer
        
        Unload Me
    Case 1  ' Cancel
        Unload Me
    End Select

    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


Private Sub SortOption_Click(Index As Integer)
    On Error GoTo ERRORTRAP
    Dim sCurrentRoutine$: sCurrentRoutine$ = Me.Name & ".SortOption_Click"
    
    If pbReInitializing Then Exit Sub
    
    ptaSortCriteria(HScroll.Value).iDirection = Index
    
    Exit Sub
ERRORTRAP:
    Call goError.xLog(Err.Number, sCurrentRoutine, Err.Description)
    Resume Next
End Sub


